package net.minecraft.block.state.pattern;

import com.google.common.base.Joiner;
import com.google.common.base.Predicate;
import com.google.common.base.Predicates;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;

public class FactoryBlockPattern
{
    private static final Joiner field_177667_a = Joiner.on(",");
    private final List field_177665_b = Lists.newArrayList();
    private final Map field_177666_c = Maps.newHashMap();
    private int field_177663_d;
    private int field_177664_e;
    private static final String __OBFID = "CL_00002021";

    private FactoryBlockPattern()
    {
        this.field_177666_c.put(' ', Predicates.alwaysTrue());
    }

    public FactoryBlockPattern aisle(String ... p_177659_1_)
    {
        if (!ArrayUtils.isEmpty(p_177659_1_) && !StringUtils.isEmpty(p_177659_1_[0]))
        {
            if (this.field_177665_b.isEmpty())
            {
                this.field_177663_d = p_177659_1_.length;
                this.field_177664_e = p_177659_1_[0].length();
            }

            if (p_177659_1_.length != this.field_177663_d)
            {
                throw new IllegalArgumentException("Expected aisle with height of " + this.field_177663_d + ", but was given one with a height of " + p_177659_1_.length + ")");
            }
            else
            {
                String[] astring = p_177659_1_;
                int i = p_177659_1_.length;

                for (int j = 0; j < i; ++j)
                {
                    String s1 = astring[j];

                    if (s1.length() != this.field_177664_e)
                    {
                        throw new IllegalArgumentException("Not all rows in the given aisle are the correct width (expected " + this.field_177664_e + ", found one with " + s1.length() + ")");
                    }

                    char[] achar = s1.toCharArray();
                    int k = achar.length;

                    for (int l = 0; l < k; ++l)
                    {
                        char c0 = achar[l];

                        if (!this.field_177666_c.containsKey(Character.valueOf(c0)))
                        {
                            this.field_177666_c.put(Character.valueOf(c0), (Object)null);
                        }
                    }
                }

                this.field_177665_b.add(p_177659_1_);
                return this;
            }
        }
        else
        {
            throw new IllegalArgumentException("Empty pattern for aisle");
        }
    }

    public static FactoryBlockPattern start()
    {
        return new FactoryBlockPattern();
    }

    public FactoryBlockPattern where(char p_177662_1_, Predicate p_177662_2_)
    {
        this.field_177666_c.put(Character.valueOf(p_177662_1_), p_177662_2_);
        return this;
    }

    public BlockPattern build()
    {
        return new BlockPattern(this.func_177658_c());
    }

    private Predicate[][][] func_177658_c()
    {
        this.func_177657_d();
        Predicate[][][] apredicate = (Predicate[][][])((Predicate[][][])Array.newInstance(Predicate.class, new int[] {this.field_177665_b.size(), this.field_177663_d, this.field_177664_e}));

        for (int i = 0; i < this.field_177665_b.size(); ++i)
        {
            for (int j = 0; j < this.field_177663_d; ++j)
            {
                for (int k = 0; k < this.field_177664_e; ++k)
                {
                    apredicate[i][j][k] = (Predicate)this.field_177666_c.get(Character.valueOf(((String[])this.field_177665_b.get(i))[j].charAt(k)));
                }
            }
        }

        return apredicate;
    }

    private void func_177657_d()
    {
        ArrayList arraylist = Lists.newArrayList();
        Iterator iterator = this.field_177666_c.entrySet().iterator();

        while (iterator.hasNext())
        {
            Entry entry = (Entry)iterator.next();

            if (entry.getValue() == null)
            {
                arraylist.add(entry.getKey());
            }
        }

        if (!arraylist.isEmpty())
        {
            throw new IllegalStateException("Predicates for character(s) " + field_177667_a.join(arraylist) + " are missing");
        }
    }
}