package net.minecraft.client.renderer;

import java.util.Arrays;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.Vec3i;
import net.minecraft.world.ChunkCache;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class RegionRenderCache extends ChunkCache
{
    private static final IBlockState field_175632_f = Blocks.air.getDefaultState();
    private final BlockPos field_175633_g;
    private int[] field_175634_h;
    private IBlockState[] field_175635_i;
    private static final String __OBFID = "CL_00002565";

    public RegionRenderCache(World worldIn, BlockPos p_i46273_2_, BlockPos p_i46273_3_, int p_i46273_4_)
    {
        super(worldIn, p_i46273_2_, p_i46273_3_, p_i46273_4_);
        this.field_175633_g = p_i46273_2_.subtract(new Vec3i(p_i46273_4_, p_i46273_4_, p_i46273_4_));
        boolean flag = true;
        this.field_175634_h = new int[8000];
        Arrays.fill(this.field_175634_h, -1);
        this.field_175635_i = new IBlockState[8000];
    }

    public TileEntity getTileEntity(BlockPos pos)
    {
        int i = (pos.getX() >> 4) - this.chunkX;
        int j = (pos.getZ() >> 4) - this.chunkZ;
        return this.chunkArray[i][j].func_177424_a(pos, Chunk.EnumCreateEntityType.QUEUED);
    }

    public int getCombinedLight(BlockPos p_175626_1_, int p_175626_2_)
    {
        int j = this.func_175630_e(p_175626_1_);
        int k = this.field_175634_h[j];

        if (k == -1)
        {
            k = super.getCombinedLight(p_175626_1_, p_175626_2_);
            this.field_175634_h[j] = k;
        }

        return k;
    }

    public IBlockState getBlockState(BlockPos pos)
    {
        int i = this.func_175630_e(pos);
        IBlockState iblockstate = this.field_175635_i[i];

        if (iblockstate == null)
        {
            iblockstate = this.func_175631_c(pos);
            this.field_175635_i[i] = iblockstate;
        }

        return iblockstate;
    }

    private IBlockState func_175631_c(BlockPos p_175631_1_)
    {
        if (p_175631_1_.getY() >= 0 && p_175631_1_.getY() < 256)
        {
            int i = (p_175631_1_.getX() >> 4) - this.chunkX;
            int j = (p_175631_1_.getZ() >> 4) - this.chunkZ;
            return this.chunkArray[i][j].getBlockState(p_175631_1_);
        }
        else
        {
            return field_175632_f;
        }
    }

    private int func_175630_e(BlockPos p_175630_1_)
    {
        int i = p_175630_1_.getX() - this.field_175633_g.getX();
        int j = p_175630_1_.getY() - this.field_175633_g.getY();
        int k = p_175630_1_.getZ() - this.field_175633_g.getZ();
        return i * 400 + k * 20 + j;
    }
}