package net.minecraft.item;

import net.minecraft.block.Block;
import net.minecraft.block.BlockDoor;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;

public class ItemDoor extends Item
{
    private Block field_179236_a;
    private static final String __OBFID = "CL_00000020";

    public ItemDoor(Block p_i45788_1_)
    {
        this.field_179236_a = p_i45788_1_;
        this.setCreativeTab(CreativeTabs.tabRedstone);
    }

    /**
     * Called when a Block is right-clicked with this Item
     *  
     * @param pos The block being right-clicked
     * @param side The side being right-clicked
     */
    public boolean onItemUse(ItemStack stack, EntityPlayer playerIn, World worldIn, BlockPos pos, EnumFacing side, float hitX, float hitY, float hitZ)
    {
        if (side != EnumFacing.UP)
        {
            return false;
        }
        else
        {
            IBlockState iblockstate = worldIn.getBlockState(pos);
            Block block = iblockstate.getBlock();

            if (!block.isReplaceable(worldIn, pos))
            {
                pos = pos.offset(side);
            }

            if (!playerIn.func_175151_a(pos, side, stack))
            {
                return false;
            }
            else if (!this.field_179236_a.canPlaceBlockAt(worldIn, pos))
            {
                return false;
            }
            else
            {
                func_179235_a(worldIn, pos, EnumFacing.fromAngle((double)playerIn.rotationYaw), this.field_179236_a);
                --stack.stackSize;
                return true;
            }
        }
    }

    public static void func_179235_a(World worldIn, BlockPos p_179235_1_, EnumFacing p_179235_2_, Block p_179235_3_)
    {
        BlockPos blockpos1 = p_179235_1_.offset(p_179235_2_.rotateY());
        BlockPos blockpos2 = p_179235_1_.offset(p_179235_2_.rotateYCCW());
        int i = (worldIn.getBlockState(blockpos2).getBlock().isNormalCube() ? 1 : 0) + (worldIn.getBlockState(blockpos2.offsetUp()).getBlock().isNormalCube() ? 1 : 0);
        int j = (worldIn.getBlockState(blockpos1).getBlock().isNormalCube() ? 1 : 0) + (worldIn.getBlockState(blockpos1.offsetUp()).getBlock().isNormalCube() ? 1 : 0);
        boolean flag = worldIn.getBlockState(blockpos2).getBlock() == p_179235_3_ || worldIn.getBlockState(blockpos2.offsetUp()).getBlock() == p_179235_3_;
        boolean flag1 = worldIn.getBlockState(blockpos1).getBlock() == p_179235_3_ || worldIn.getBlockState(blockpos1.offsetUp()).getBlock() == p_179235_3_;
        boolean flag2 = false;

        if (flag && !flag1 || j > i)
        {
            flag2 = true;
        }

        BlockPos blockpos3 = p_179235_1_.offsetUp();
        IBlockState iblockstate = p_179235_3_.getDefaultState().withProperty(BlockDoor.FACING_PROP, p_179235_2_).withProperty(BlockDoor.HINGEPOSITION_PROP, flag2 ? BlockDoor.EnumHingePosition.RIGHT : BlockDoor.EnumHingePosition.LEFT);
        worldIn.setBlockState(p_179235_1_, iblockstate.withProperty(BlockDoor.HALF_PROP, BlockDoor.EnumDoorHalf.LOWER), 2);
        worldIn.setBlockState(blockpos3, iblockstate.withProperty(BlockDoor.HALF_PROP, BlockDoor.EnumDoorHalf.UPPER), 2);
        worldIn.notifyNeighborsOfStateChange(p_179235_1_, p_179235_3_);
        worldIn.notifyNeighborsOfStateChange(blockpos3, p_179235_3_);
    }
}