package net.minecraft.network.login.server;

import com.mojang.authlib.GameProfile;
import java.io.IOException;
import java.util.UUID;
import net.minecraft.network.INetHandler;
import net.minecraft.network.Packet;
import net.minecraft.network.PacketBuffer;
import net.minecraft.network.login.INetHandlerLoginClient;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class S02PacketLoginSuccess implements Packet
{
    private GameProfile profile;
    private static final String __OBFID = "CL_00001375";

    public S02PacketLoginSuccess() {}

    public S02PacketLoginSuccess(GameProfile profileIn)
    {
        this.profile = profileIn;
    }

    /**
     * Reads the raw packet data from the data stream.
     */
    public void readPacketData(PacketBuffer data) throws IOException
    {
        String s = data.readStringFromBuffer(36);
        String s1 = data.readStringFromBuffer(16);
        UUID uuid = UUID.fromString(s);
        this.profile = new GameProfile(uuid, s1);
    }

    /**
     * Writes the raw packet data to the data stream.
     */
    public void writePacketData(PacketBuffer data) throws IOException
    {
        UUID uuid = this.profile.getId();
        data.writeString(uuid == null ? "" : uuid.toString());
        data.writeString(this.profile.getName());
    }

    public void func_180771_a(INetHandlerLoginClient p_180771_1_)
    {
        p_180771_1_.handleLoginSuccess(this);
    }

    @SideOnly(Side.CLIENT)
    public GameProfile func_179730_a()
    {
        return this.profile;
    }

    /**
     * Passes this Packet on to the NetHandler for processing.
     */
    public void processPacket(INetHandler handler)
    {
        this.func_180771_a((INetHandlerLoginClient)handler);
    }
}