package net.minecraft.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.Random;

public class WeightedRandom
{
    private static final String __OBFID = "CL_00001503";

    /**
     * Returns the total weight of all items in a collection.
     */
    public static int getTotalWeight(Collection p_76272_0_)
    {
        int i = 0;
        WeightedRandom.Item item;

        for (Iterator iterator = p_76272_0_.iterator(); iterator.hasNext(); i += item.itemWeight)
        {
            item = (WeightedRandom.Item)iterator.next();
        }

        return i;
    }

    /**
     * Returns a random choice from the input items, with a total weight value.
     */
    public static WeightedRandom.Item getRandomItem(Random p_76273_0_, Collection p_76273_1_, int p_76273_2_)
    {
        if (p_76273_2_ <= 0)
        {
            throw new IllegalArgumentException();
        }
        else
        {
            int j = p_76273_0_.nextInt(p_76273_2_);
            return func_180166_a(p_76273_1_, j);
        }
    }

    public static WeightedRandom.Item func_180166_a(Collection p_180166_0_, int p_180166_1_)
    {
        Iterator iterator = p_180166_0_.iterator();
        WeightedRandom.Item item;

        do
        {
            if (!iterator.hasNext())
            {
                return null;
            }

            item = (WeightedRandom.Item)iterator.next();
            p_180166_1_ -= item.itemWeight;
        }
        while (p_180166_1_ >= 0);

        return item;
    }

    /**
     * Returns a random choice from the input items.
     */
    public static WeightedRandom.Item getRandomItem(Random p_76271_0_, Collection p_76271_1_)
    {
        /**
         * Returns a random choice from the input items, with a total weight value.
         */
        return getRandomItem(p_76271_0_, p_76271_1_, getTotalWeight(p_76271_1_));
    }

    public static class Item
        {
            /** The Weight is how often the item is chosen(higher number is higher chance(lower is lower)) */
            public int itemWeight;
            private static final String __OBFID = "CL_00001504";

            public Item(int p_i1556_1_)
            {
                this.itemWeight = p_i1556_1_;
            }
        }
}