package net.minecraft.server.gui;

import com.mojang.util.QueueLogAppender;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.dedicated.DedicatedServer;
import net.minecraft.server.gui.PlayerListComponent;
import net.minecraft.server.gui.StatsComponent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@SideOnly(Side.SERVER)
public class MinecraftServerGui extends JComponent {

   private static final Font field_164249_a = new Font("Monospaced", 0, 12);
   private static final Logger field_164248_b = LogManager.getLogger();
   private DedicatedServer field_120021_b;
   private static final String __OBFID = "CL_00001789";

   public static void func_120016_a(final DedicatedServer p_120016_0_) {
      try {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      } catch (Exception var3) {
         ;
      }

      MinecraftServerGui var1 = new MinecraftServerGui(p_120016_0_);
      JFrame var2 = new JFrame("Minecraft server");
      var2.add(var1);
      var2.pack();
      var2.setLocationRelativeTo((Component)null);
      var2.setVisible(true);
      var2.addWindowListener(new WindowAdapter() {

         private static final String __OBFID = "CL_00001791";

         public void windowClosing(WindowEvent p_windowClosing_1_) {
            p_120016_0_.func_71263_m();

            while(!p_120016_0_.func_71241_aa()) {
               try {
                  Thread.sleep(100L);
               } catch (InterruptedException var3) {
                  var3.printStackTrace();
               }
            }

            System.exit(0);
         }
      });
   }

   public MinecraftServerGui(DedicatedServer p_i2362_1_) {
      this.field_120021_b = p_i2362_1_;
      this.setPreferredSize(new Dimension(854, 480));
      this.setLayout(new BorderLayout());

      try {
         this.add(this.func_120018_d(), "Center");
         this.add(this.func_120019_b(), "West");
      } catch (Exception var3) {
         field_164248_b.error("Couldn\'t build server GUI", var3);
      }

   }

   private JComponent func_120019_b() {
      JPanel var1 = new JPanel(new BorderLayout());
      var1.add(new StatsComponent(this.field_120021_b), "North");
      var1.add(this.func_120020_c(), "Center");
      var1.setBorder(new TitledBorder(new EtchedBorder(), "Stats"));
      return var1;
   }

   private JComponent func_120020_c() {
      PlayerListComponent var1 = new PlayerListComponent(this.field_120021_b);
      JScrollPane var2 = new JScrollPane(var1, 22, 30);
      var2.setBorder(new TitledBorder(new EtchedBorder(), "Players"));
      return var2;
   }

   private JComponent func_120018_d() {
      JPanel var1 = new JPanel(new BorderLayout());
      final JTextArea var2 = new JTextArea();
      final JScrollPane var3 = new JScrollPane(var2, 22, 30);
      var2.setEditable(false);
      var2.setFont(field_164249_a);
      final JTextField var4 = new JTextField();
      var4.addActionListener(new ActionListener() {

         private static final String __OBFID = "CL_00001790";

         public void actionPerformed(ActionEvent p_actionPerformed_1_) {
            String var2 = var4.getText().trim();
            if(var2.length() > 0) {
               MinecraftServerGui.this.field_120021_b.func_71331_a(var2, MinecraftServer.func_71276_C());
            }

            var4.setText("");
         }
      });
      var2.addFocusListener(new FocusAdapter() {

         private static final String __OBFID = "CL_00001794";

         public void focusGained(FocusEvent p_focusGained_1_) {}
      });
      var1.add(var3, "Center");
      var1.add(var4, "South");
      var1.setBorder(new TitledBorder(new EtchedBorder(), "Log and chat"));
      Thread var5 = new Thread(new Runnable() {

         private static final String __OBFID = "CL_00001793";

         public void run() {
            String var1;
            while((var1 = QueueLogAppender.getNextLogEvent("ServerGuiConsole")) != null) {
               MinecraftServerGui.this.func_164247_a(var2, var3, var1);
            }

         }
      });
      var5.setDaemon(true);
      var5.start();
      return var1;
   }

   public void func_164247_a(final JTextArea p_164247_1_, final JScrollPane p_164247_2_, final String p_164247_3_) {
      if(!SwingUtilities.isEventDispatchThread()) {
         SwingUtilities.invokeLater(new Runnable() {

            private static final String __OBFID = "CL_00001792";

            public void run() {
               MinecraftServerGui.this.func_164247_a(p_164247_1_, p_164247_2_, p_164247_3_);
            }
         });
      } else {
         Document var4 = p_164247_1_.getDocument();
         JScrollBar var5 = p_164247_2_.getVerticalScrollBar();
         boolean var6 = false;
         if(p_164247_2_.getViewport().getView() == p_164247_1_) {
            var6 = (double)var5.getValue() + var5.getSize().getHeight() + (double)(field_164249_a.getSize() * 4) > (double)var5.getMaximum();
         }

         try {
            var4.insertString(var4.getLength(), p_164247_3_, (AttributeSet)null);
         } catch (BadLocationException var8) {
            ;
         }

         if(var6) {
            var5.setValue(Integer.MAX_VALUE);
         }

      }
   }

}